pro plo_finish_flagging,plid,sindex
; This routine finishes up the flagging process by finalizing all the 
; selections and redrawing the plot
;
; parameters 
;	     : plid - plot index - index into pl array structure
;	     : sindex - index into con,gai,wlm, etc array
;
; 
; Written by:  Kim Drongesen
; Date:  December 16, 1998

common global
common plo

; This routine owes its awkwardness to the fact that I don't want
; to copy in the entire structure into s_page for one instruction

case pl[plid].plot_type of
      'con':  begin
		if con[sindex].n_select gt 0 then begin
   	      	con[sindex].wts(con[sindex].j_select)=float(con[sindex].m_button_select)* $
                  abs(con[sindex].wts(con[sindex].j_select))
	   	endif
	      end
      'spe':  begin
		if spe[sindex].n_select gt 0 then begin
   	      	spe[sindex].wts(spe[sindex].j_select)=float(spe[sindex].m_button_select)* $
                  abs(spe[sindex].wts(spe[sindex].j_select))
	   	endif
	      end
      'gai':  begin
		if gai[sindex].n_select gt 0 then begin
   	      	gai[sindex].wts(gai[sindex].j_select)=float(gai[sindex].m_button_select)* $
                  abs(gai[sindex].wts(gai[sindex].j_select))
	   	endif
	      end
      'pas':  begin
		if pas[sindex].n_select gt 0 then begin
   	      	pas[sindex].wts(pas[sindex].j_select)=float(pas[sindex].m_button_select)* $
                  abs(pas[sindex].wts(pas[sindex].j_select))
	   	endif
	      end
      'wlm':  begin
		if wlm[sindex].n_select gt 0 then begin
   	      	wlm[sindex].wts(wlm[sindex].j_select)=float(wlm[sindex].m_button_select)* $
                  abs(wlm[sindex].wts(wlm[sindex].j_select))
	   	endif
	      end
endcase

result=plo_page(plid,sindex)

case pl[plid].plot_type of
    'gai':  begin
      	       gai[sindex].nsub=2
               result=plo_over_page(plid,sindex)
               gai[sindex].nsub=3
            end
    'pas':  begin
               pas[sindex].nsub=2
       	       result=plo_over_page(plid,sindex)
       	    end
else:
endcase

return
end
