pro readdata,directory=directory, int_read=int_read, skip=skip, full=full
;yes
;=Task:READDATA --- To read data from specified directory
;#Type: i/o
;
;+Use:
;      READDATA will read raw SMA data from, by default, the current directory. 
;      If you want to read a data set called mydata from a different directory,
;      /home/smauser/ for example,  you can use
;      >readdata,dir='/home/smauser/mydata'
;      Specifying the directory will change the default to the specified 
;      directory.
;
;&history
;------------------------------------------------------------------------
;      cykuo 10feb04 adapting the header
;------------------------------------------------------------------------ 

common global
common data_set
common wlm

;print,directory
;print,keyword_set(directory) 

if keyword_set(directory) then begin
    nchar = strlen(directory)
    checkslash = strmid(directory,nchar-1,1)
    if ( strmatch(checkslash,'/') le 0 ) then directory = directory + '/'
    e.idl_bcp=directory

    count = 0
    result = findfile(e.idl_bcp+'in_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'in_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'bl_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'bl_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'sp_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'sp_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'codes_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'codes_read'
        return
    endif
    count = 0
    result = findfile(e.idl_bcp+'sch_read',count=count)
    if (count eq 0) then begin
        print,'could not find file ',e.idl_bcp+'sch_read'
        return
    endif

    if keyword_set(full) then begin
       result=dbi_read_data()
    endif else begin
       result=dbi_head_read_short()
       result=dbi_chan_read_short()
       if result lt 0 then result=dbi_chan_read()
    endelse
 endif else begin
    if keyword_set(full) then begin
       result=dbi_read_data()
    endif else begin
       result=dbi_head_read_short()
       result=dbi_chan_read_short()
       if result lt 0 then result=dbi_chan_read()
    endelse
 endelse
res=dat_list(s_l,'"band" eq "c1"',/reset,/no_notify)
cont_bw=(n_elements(c.band)-1.)*82.
if sp[psl[0]].fres ne cont_bw then sp[psl].fres = (sp[psl].fres/abs(sp[psl].fres)) * cont_bw
res=dat_list(s_l,/reset)
end
