pro uti_vel_fix, ref=ref, band=band

common global
common data_set

if (keyword_set(ref) eq 0 or (keyword_set(band) eq 0)) then begin
   print, 'Please set the reference band and the target band '
   print, 'with keywords ref and band, Quit!'
   return
endif


if (strpos(ref,'s') eq -1 or strpos(band,'s') eq -1) then begin
   print, 'Please check the input band name again !'
   print, 'No velocity change made, Quit!'
   return
endif

result=dat_filter(s_s,/save,/no_notify)
command='"band" eq "'+ref+'"'
result=dat_filter(s_f,command,/no_notify,/reset)

freq_ref=sp[psf].fsky
vel_ref=sp[psf].vel

command='"band" eq "'+band+'"'
result1=dat_filter(s_f,command,/no_notify,/reset)

if result ne result1 then begin
   print, 'Inconsistent scan numbers for both bands, Quit!'
   return
endif

freq_new=sp[psf].fsky

alpha=(double(freq_new)/freq_ref)^2
;print,sp[psl].vel
;print,vel_ref-(alpha-1)*!cvel/(1000.d*(alpha+1))
sp[psf].vel=vel_ref-(alpha-1)*!cvel/(1000.d*(alpha+1))

result=dat_filter(s_s,/restore,/no_notify)
print, 'Velocity fixed on band '+band+' using band '+ref 
end
